import javax.microedition.lcdui.*;
import java.util.*;

public class SearchBox extends Form implements CommandListener { 
 midlet  midlet;
 Displayable parent;
 Vector items,date1,date2;
 TextField text;
 ChoiceGroup ext;
 int mode;

 SearchBox (Vector items, midlet midlet, Displayable parent,int mode) {
  super (Settings.SearchHdr+" ("+items.size()+")");
  this.items = items;
  this.parent = parent;
  this.midlet = midlet;
  this.mode = mode;
  setCommandListener(this);
  if (items.size()>0) addCommand(midlet.SEARCH_CMD);
  addCommand(midlet.BACK_CMD);
  if (mode==1)
   text=new TextField (Settings.DateSearchHdr, "", 4, TextField.NUMERIC);
  else
   text=new TextField (Settings.WordSearchHdr, "", 20, TextField.ANY);
  append (text);
  if (mode==1) {
   ext = new ChoiceGroup ("", Choice.EXCLUSIVE, Settings.dateTypes, null);
   append (ext);
   ext.setSelectedIndex (Settings.lastIndex,true);
  }
  Display.getDisplay(midlet).setCurrent(this);
 }

 SearchBox (Vector items, midlet midlet, Displayable parent) {
  this (items,midlet,parent,2);
 }

 SearchBox (Vector items, Vector date1, Vector date2, midlet midlet, Displayable parent) {
  this (items,midlet,parent,1);
  this.date1=date1;
  this.date2=date2;
 }

 public void commandAction(Command c, Displayable d) {    
  if (c == midlet.SEARCH_CMD) {
   String txt = text.getString().trim();
   if (txt.length()<1) {
    new Message (midlet, this, Settings.AlertHdr).show (Settings.NoTextString);
    return;
   }
   if (mode==1) {
    Settings.lastIndex=ext.getSelectedIndex();
    new ElementList (Settings.FoundHdr, search(items, date1, date2, txt), midlet, this);
   }
   else {
    new ElementList (Settings.FoundHdr, search(items, txt), midlet, this);
   }
  }
  else { 
   Display.getDisplay(midlet).setCurrent(parent);
  }
 }

 public static String upperStr =
  "ABWGDEVZIJKLMNOPRSTUFHCQYXŨ";
 public static String lowerStr =
  "abwgdevzijklmnoprstufhcqyx";
 public String toUpperCase(String in) {
  String out="";
  char c; 
  int n,l=in.length();
  for (int i=0; i<l; i++) {
   c=in.charAt (i);
   n=lowerStr.indexOf(c);
   if (n>-1) out+=upperStr.charAt(n);
   else out+=c;
  }
  return out;
 }

 public Vector search (Vector items, String pattern) {
  Vector result = new Vector();
  pattern = toUpperCase(pattern.trim());
  String item,item2;
  int n=items.size (),i,p=0;
  for (i=0; i<n; i++) {
   item=items.elementAt(i).toString().trim();
   item2=toUpperCase(item);
   if (item2.indexOf(pattern)>-1) result.addElement (item);
   if (i%10==0) {
    if ((i*100)/n>p) {
     p=(i*100)/n;
     setTitle (Settings.SearchHdr+":"+p+"%");
    }
   }
  }
  setTitle (Settings.SearchHdr);
  return result;
 }

 public Vector search (Vector items, Vector date1, Vector date2, String pattern) {
  Vector result = new Vector();
  int item1,item2,item=Integer.parseInt(pattern);
  int n=items.size (),i,p=0,coef;
  String stritem;
  switch (Settings.lastIndex) {
   case 0: coef=10000; break;
   case 1:
    coef=100000;
    while (item>1000) item/=10;
   break;
   default: 
    coef=1000000;
    while (item>100) item/=100;
   break;
  }
  for (i=0; i<n; i++) {
   stritem=items.elementAt(i).toString().trim();
   item1=Integer.parseInt(date1.elementAt(i).toString());
   item2=Integer.parseInt(date2.elementAt(i).toString());
   if ((item>=item1/coef) && (item<=item2/coef)) result.addElement (stritem);
   if (i%10==0) {
    if ((i*100)/n>p) {
     p=(i*100)/n;
     setTitle (Settings.SearchHdr+":"+p+"%");
    }
   }
  }
  setTitle (Settings.SearchHdr);
  return result;
 }

}